#pragma once

#include <map>
#include <mutex>
#include <optional>
#include <string>

#include <RobotAPI/libraries/armem/core/MemoryID.h>

namespace armarx::armem::server::ltm
{
    /// @brief Interface functions for the longterm memory classes
    class MemoryItem
    {
    public:
        MemoryItem() = default;
        MemoryItem(const MemoryID&);

        MemoryID id() const;
        std::string name() const;

        virtual void setMemoryID(const MemoryID&);

    private:
        MemoryID _id;
    };
} // namespace armarx::armem::server::ltm
