#pragma once

// Base Class
#include "../Extractor.h"

#include <RobotAPI/libraries/aron/core/data/visitor/variant/VariantVisitor.h>

namespace armarx::armem::server::ltm::extractor
{
    class ImageExtractor;
    typedef std::shared_ptr<ImageExtractor> ImageExtractorPtr;

    class ImageExtractorVisitor : public aron::data::RecursiveVariantVisitor
    {
    public:
        std::map<std::string, aron::data::NDArrayPtr> images;

        void visitNDArray(const std::string& key, Input& parent, Input& data);
    };

    class ImageExtractor : public Extractor
    {
    public:
        ImageExtractor() = default;

        virtual Extraction extract(aron::data::DictPtr& data) override;
        virtual aron::data::DictPtr merge(Extraction& encoding) override;
    };
}
