#pragma once

#include <filesystem>

// Base Class
#include "../base/detail/CoreSegmentBase.h"
#include "detail/DiskStorage.h"

#include "ProviderSegment.h"

namespace armarx::armem::server::ltm::disk
{
    class CoreSegment :
            public CoreSegmentBase<ProviderSegment>,
            public DiskStorage
    {
    public:
        CoreSegment(const std::filesystem::path&);

        bool forEachProviderSegment(std::function<void(ProviderSegment&)>&& func) const override;

        std::shared_ptr<ProviderSegment> findProviderSegment(const std::string&) const override;

    protected:
        void _loadAll(armem::wm::CoreSegment&) override;
        void _load(armem::wm::CoreSegment&) override;
        void _store(const armem::wm::CoreSegment&) override;

        std::string getExpectedFolderName() const override;
    };

} // namespace armarx::armem::server::ltm::disk
