#pragma once

#include <filesystem>

// Base Class
#include "../base/detail/BufferedMemoryBase.h"
#include "detail/DiskStorage.h"

// Segmnet Type
#include "CoreSegment.h"

// Config
#include "../base/filter/frequencyFilter/FrequencyFilter.h"


namespace armarx::armem::server::ltm::disk
{
    /// @brief A memory storing data in mongodb (needs 'armarx memory start' to start the mongod instance)
    class Memory :
            public BufferedMemoryBase<CoreSegment>,
            public DiskStorage
    {
    public:
        Memory();
        Memory(const std::filesystem::path&);

        bool forEachCoreSegment(std::function<void(CoreSegment&)>&& func) const override;

        std::shared_ptr<CoreSegment> findCoreSegment(const std::string&) const override;

    protected:
        void _loadAll(armem::wm::Memory&) override;
        void _load(armem::wm::Memory&) override;
        void _directlyStore(const armem::wm::Memory&) override;

        std::string getExpectedFolderName() const override;

    };
} // namespace armarx::armem::server::ltm::disk
