#pragma once

#include <filesystem>

// Base Class
#include "../base/detail/ProviderSegmentBase.h"
#include "detail/DiskStorage.h"

#include "Entity.h"

namespace armarx::armem::server::ltm::disk
{
    class ProviderSegment :
            public ProviderSegmentBase<Entity>,
            public DiskStorage
    {
    public:
        ProviderSegment(const std::filesystem::path&);

        bool forEachEntity(std::function<void(Entity&)>&& func) const override;

        std::shared_ptr<Entity> findEntity(const std::string&) const override;

    protected:
        void _loadAll(armem::wm::ProviderSegment&) override;
        void _load(armem::wm::ProviderSegment&) override;
        void _store(const armem::wm::ProviderSegment&) override;

        std::string getExpectedFolderName() const override;
    };

} // namespace armarx::armem::server::ltm::disk
