#include "ReadWritePluginUser.h"
#include "Plugin.h"

#include <RobotAPI/libraries/armem/core/error.h>
#include <RobotAPI/libraries/armem/server/MemoryToIceAdapter.h>

#include <ArmarXCore/core/Component.h>
#include <ArmarXCore/core/exceptions/local/ExpressionException.h>



namespace armarx::armem::server::plugins
{

    ReadWritePluginUser::ReadWritePluginUser()
    {
        addPlugin(plugin);
    }


    ReadWritePluginUser::~ReadWritePluginUser()
    {
    }


    void ReadWritePluginUser::setMemoryName(const std::string& memoryName)
    {
        plugin->setMemoryName(memoryName);
    }


    // WRITING
    data::AddSegmentsResult ReadWritePluginUser::addSegments(const data::AddSegmentsInput& input, const Ice::Current&)
    {
        ARMARX_TRACE;
        bool addCoreSegmentOnUsage = false;
        return addSegments(input, addCoreSegmentOnUsage);
    }

    data::AddSegmentsResult ReadWritePluginUser::addSegments(const data::AddSegmentsInput& input, bool addCoreSegments)
    {
        ARMARX_TRACE;
        data::AddSegmentsResult result = iceAdapter().addSegments(input, addCoreSegments);
        return result;
    }


    data::CommitResult ReadWritePluginUser::commit(const data::Commit& commitIce, const Ice::Current&)
    {
        ARMARX_TRACE;
        return iceAdapter().commit(commitIce);
    }


    // READING
    armem::query::data::Result ReadWritePluginUser::query(const armem::query::data::Input& input, const Ice::Current&)
    {
        ARMARX_TRACE;
        return iceAdapter().query(input);
    }


    // LTM STORING
    data::StoreResult ReadWritePluginUser::store(const data::StoreInput& input, const Ice::Current&)
    {
        ARMARX_TRACE;
        return iceAdapter().store(input);
    }


    Plugin& ReadWritePluginUser::memoryServerPlugin()
    {
        return *plugin;
    }


    wm::Memory& ReadWritePluginUser::workingMemory()
    {
        return plugin->workingMemory;
    }


    MemoryToIceAdapter& ReadWritePluginUser::iceAdapter()
    {
        return plugin->iceAdapter;
    }


    bool ReadWritePluginUser::isLongtermMemoryEnabled()
    {
        return plugin->longtermMemoryEnabled;
    }


    ltm::disk::Memory& ReadWritePluginUser::longtermMemoryManager()
    {
        return plugin->longtermMemory;
    }

}
