#pragma once

// STD/STL
#include <mutex>
#include <string>

// BaseClass
#include <RobotAPI/libraries/armem/server/segment/Segment.h>

// ArmarX
#include <RobotAPI/libraries/armem_motions/aron/MDBReference.aron.generated.h>


namespace armarx::armem::server::motions::mdb
{
    class Segment : public armem::server::segment::wm::AronTypedProviderSegmentBase<armarx::armem::mdb::MDBReference>
    {
        using Base = armem::server::segment::wm::AronTypedProviderSegmentBase<armarx::armem::mdb::MDBReference>;

    public:
        Segment(armem::server::MemoryToIceAdapter& iceMemory);

        virtual void defineProperties(armarx::PropertyDefinitionsPtr defs, const std::string& prefix = "") override;
        virtual void onInit() override;
        virtual void onConnect();

    private:
        int loadByMotionFinder(const std::string&);

    private:
        struct Properties
        {
            std::string motionsPackage = "PriorKnowledgeData";
            bool loadFromMotionsPackage = true;
        };
        Properties p;
    };
}
